# encoding: Windows-31J
  # CommandBars Id, Caption [NV[gɏo
require "exlap"
ary = []
filename = "CommandBars.xls"
Exlap.new(filename) do |wb|
  app = wb.app.obj
  controls = {}
  app.CommandBars.each do |bars|
    key = [bars.Index, bars.Name]
    controls[key] = []
    app.CommandBars(bars.Name).Controls.each do |target|
      controls[key] << [target.Index, target.Id, target.Caption]
    end
  end
  ary << [nil, "Index", "Id", "Caption"]
  controls.sort.each do |key, val|
    i, name = key
    ary << ["*#{i} #{name}"]
    val.sort.each do |idx, id, caption|
      ary << [nil, idx, id, caption]
    end
  end
  ly,lx = [ary.size, 4]
  ss = wb.fes
  ss.rr(1,1, ly,lx).Value = ary
  for y in 2..ly
    if ary[y-1][0]
      ss.rr(y,1, y,4).MergeCells = true
    end
  end
  ss.range_autofit
  wb.save
end
    # eLXgt@CƂďo
body_str = ''
ary.each do |row|
  str = row.join("\t")
  body_str += str.gsub(/(\d)\.0+\t/, "\\1\t") + "\n"
end
File.open("CommandBars.txt", "w") {|ff|  ff.write body_str}
