# encoding: Windows-31J
  # {ƂƕƂ̂Qނ̃ViI̗v񃌃|[g
require "exlap"
require "csv"

    # O`csv
cell_names_format = <<EON
^Cg
x
,,xo,v
,Ǝ,Ǝxo,Ɨv
Z,Z,Zxo,Zv
EON
cell_names = CSV.parse(cell_names_format)  # csvzɕϊ

    # Z̒lcsv
cell_values_format = <<EOV
2011Nx@ƕʎxv揑
,,xo,v
,,,=-xo
,,,=Ǝ-Ǝxo
Z,=+Ǝ,=xo+Ǝxo,=v+Ɨv
EOV
cell_values = CSV.parse(cell_values_format)  # csvzɕϊ

    # ViIcsv
scenario_group = []
scenario_data1 = <<EOS1
HX̃ViI,HX,20000000,11300000
ʐM̔̃ViI,ʐM̔,12000000,6680000
moc̃ViI,moc,30000000,20520000
EOS1
scenario_group << CSV.parse(scenario_data1)

scenario_data2 = <<EOS2
Ƃ`̃ViI,Ƃ`,1500000,100000
ƂãViI,Ƃa,1000000,50000
Ƃb̃ViI,Ƃb,750000,50000
EOS2
scenario_group << CSV.parse(scenario_data2)

filename = "test03_4.xls"
Exlap.new(filename) {|wb|
  ss = wb.fes  # ̃[NV[gI
  ss.Name = "ƕʎxv揑"
      # ZɖOt
  cell_names.each_with_index {|list, r|
    list.each_with_index {|name, c|
      ss.Cells.Item(r+1, c+1).Name = name  if name.to_s != ''
    }
  }
      # Z̒lZbg
  cell_values.each_with_index {|list, r|
    list.each_with_index {|val, c|
      ss.Cells.Item(r+1, c+1).Value = val  if val.to_s != ''
    }
  }
  ss.rr(1,1, 1,cell_values[1].size).MergeCells = true  # ^Cg̃Z
      # ZɊւ邻̑̐ݒ
  (%w( xo v) +
   %w(Ǝ Ǝxo Ɨv) +
   %w(Z Zxo Zv)).each {|name|
      ss.Range(name).NumberFormatLocal = "#,##0"  # l̕\`
  }

      # ViI̓o^
  changing_cells = [ss.Range(",,xo"),
      ss.Range(",Ǝ,Ǝxo")]
  scenario_group.each_with_index {|info, idx|
    info.each {|ary|
      name = ary[0]
      values = ary[1...ary.size]
      ss.Scenarios.Add({
          'Name'=>name,
          'ChangingCells'=>changing_cells[idx],
          'Values'=>values})
    }
  }

  ss.Scenarios("HX̃ViI").Show
  ss.Scenarios("Ƃ`̃ViI").Show
  ss.range_autofit  # Z̕ƍ

      # W^Cv̗v񃌃|[g
  ss.Scenarios.CreateSummary({
    'ReportType'=>XlStandardSummary,
    'ResultCells'=>ss.Range("v,Ɨv,Z,Zxo,Zv")})

      # s{bge[u̗v񃌃|[g
  ss.Scenarios.CreateSummary({
    'ReportType'=>XlSummaryPivotTable,
    'ResultCells'=>ss.Range(",xo,v," +
        "Ǝ,Ǝxo,Ɨv," +
        "Z,Zxo,Zv")})
  wb.save
}
