# encoding: Windows-31J
# display the Excel addin list, and report especially on the Solver file.
require "win32ole"
app = WIN32OLE.new("Excel.Application")
ary = []
solver_file = nil
app.AddIns.each do |target|
  ary << [target.Name, target.FullName]
  if target.Name =~ /^solver\.x/i
    solver_file = target.FullName
  end
end
app.Quit
unless solver_file
  puts 'can not find the solver addin file'
else
  puts "the solver file: #{solver_file}"
end
printf("\n")
puts 'Excel addin list'
ary.each do |row|
  puts row.join("\t")
end
