# encoding: Windows-31J
  # the sample for UserForm
require "wrdap"
uf_str, mdl_str = DATA.read.split(/\n########\n+/)
filename = "wmcr13.doc"
File.unlink(filename)  if test(?e, filename)
Wrdap.new(filename) do |doc|
  uf = doc.macro_add(uf_str, 3, "SampleForm")  # add UserForm component
  uf.Designer.Controls.Add("Forms.TextBox.1")  # add TextBox
  uf.Designer.Controls.Add("Forms.ListBox.1")  # add ListBox
  uf.Designer.Controls.Add("Forms.CommandButton.1")  # add CommandButton
  uf.Designer.Controls.Add("Forms.CommandButton.1")  # add CommandButton
  doc.macro_add(mdl_str, 1, "Module1")  # add standard module component
  app = doc.Application
  app.CustomizationContext = doc.obj  # ۑƒ̕ɂ
  app.Keybindings.Add('KeyCategory'=>WdKeyCategoryMacro,
      'Command'=>"Module1.Macro1",
      'KeyCode'=>WdKeyControl + WdKeyShift + WdKeyU)
  slc = doc.Application.Selection
  slc.TypeText "[U[tH[eXg邽߂̃hLg"
  slc.TypeParagraph()
  slc.TypeText "Rg[L[{VtgL[{t͂āA[U[tH[ĉB"
  slc.TypeParagraph()
  doc.save
end

__END__
' UserForm module
Private Sub CommandButton1_Click()
    ActiveDocument.Paragraphs(1).Range.Text = Me.TextBox1.Value & vbCrLf
    ActiveDocument.Paragraphs(2).Range.Text = Me.ListBox1.Value & vbCrLf
    Unload Me
End Sub

Private Sub CommandButton2_Click()
    Unload Me
End Sub

Private Sub UserForm_Initialize()
    With TextBox1
        .AutoSize = True
        .MultiLine = False
    End With
    With ListBox1
        .AddItem "j"
        .AddItem "Ηj"
        .AddItem "j"
        .AddItem "ؗj"
        .AddItem "j"
    End With
    With CommandButton1
        .Caption = "Finish"
    End With
    With CommandButton2
        .Caption = "Cancel"
        .Cancel = True
    End With
End Sub

########
' standard module
Sub Macro1()
    SampleForm.Show
End Sub
