# encoding: Windows-31J
# sample11.rb: e[ǔ
require 'yado'

db = Yado.new "TEST.MDB"

tbl1 = 'e[u11_1'
sql = <<EOS1
create table #{tbl1}
   (ID int PRIMARY KEY,
     varchar(30) NOT NULL);
EOS1
db.query(sql)
ary = [%w(ID ),
       %w(1  ),
       %w(2  ),
       %w(3  ),
       %w(4  ),
       %w(5  v)]
db.addnew(tbl1, ary)

tbl2 = 'e[u11_2'
sql = <<EOS2
create table #{tbl2}
   (ID int PRIMARY KEY,
    菬 money);
EOS2
db.query(sql)
ary = [%w(ID   菬),
       %w(1    6000),
       %w(2    7000),
       %w(3    8000),
       %w(4    30000),
       %w(5    50000)]
db.addnew(tbl2, ary)

vw1 = 'e[u11_1'
sql = <<EOS3
create view #{vw1} as
    select #{tbl1}.ID, #{tbl1}., #{tbl2}.菬
    from #{tbl1}, #{tbl2}
   where #{tbl1}.ID = #{tbl2}.ID;
EOS3
db.query(sql)

vw2 = 'e[u11_2'
sql = <<EOS4
create view #{vw2} as
    select #{tbl1}.*, #{tbl2}.菬
    from #{tbl1} inner join #{tbl2}
   on #{tbl1}.ID = #{tbl2}.ID;
EOS4
db.query(sql)

puts 'sample11.rb: e[ǔ'
db.print_all_values(':::', [tbl1, tbl2, vw1, vw2])
db.close
